﻿------------------------------
--      Are you local?      --
------------------------------

local boss = AceLibrary("Babble-Boss-2.2")["Arcane Watchman"]
local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	cmd = "Watchman",

	overloadyou_cmd = "overloadyou",
	overloadyou_name = "Overload on you alert",
	overloadyou_desc = "Warn if you got the Overload",

	overloadother_cmd = "overloadother",
	overloadother_name = "Overload on others alert",
	overloadother_desc = "Warn if others got the Overload",

	overloadtrigger = "^([^%s]+) ([^%s]+) afflicted by Overload%.$",
	overloadwarn = " has Overload!",
	overloadyouwarn = "You have the Overload!",
	overloadyou = "You",
	overloadare = "are",
	
	icon_cmd = "icon",
	icon_name = "Place icon",
	icon_desc = "Place raid icon on the last overloaded person (requires promoted or higher)",
} end )


----------------------------------
--      Module Declaration      --
----------------------------------

BigWigsWatchmen = BigWigs:NewModule(boss)
BigWigsWatchmen.zonename = AceLibrary("Babble-Zone-2.2")["Karazhan"]
BigWigsWatchmen.enabletrigger = boss
BigWigsWatchmen.toggleoptions = { "overloadyou", "overloadother","icon", "bosskill"}
BigWigsWatchmen.revision = tonumber(string.sub("$Revision: 24605 $", 12, -3))

------------------------------
--      Initialization      --
------------------------------

function BigWigsWatchmen:OnEnable()
	self:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE", "Checkoverload")
	self:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE", "Checkoverload")
	self:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE", "Checkoverload")
	self:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH")

end

------------------------------
--      Event Handlers      --
------------------------------

function BigWigsWatchmen:CHAT_MSG_COMBAT_HOSTILE_DEATH(msg)
	if msg == string.format(UNITDIESOTHER, boss) then
		self.core:ToggleModuleActive(self, false)
	end
end




function BigWigsWatchmen:Checkoverload(msg)
	local pplayer, ptype = select(3, msg:find(L["overloadtrigger"]))
	if pplayer then
		if self.db.profile.overloadyou and pplayer == L["overloadyou"] then
			self:TriggerEvent("BigWigs_Message", L["overloadyouwarn"], "Personal", true)
			self:TriggerEvent("BigWigs_Message", UnitName("player") .. L["overloadwarn"], "Attention", nil, nil, true)
		elseif self.db.profile.overloadother then
			self:TriggerEvent("BigWigs_Message", pplayer .. L["overloadwarn"], "Attention")
			self:TriggerEvent("BigWigs_SendTell", pplayer, L["overloadyouwarn"])
		end

		if self.db.profile.icon then
			self:TriggerEvent("BigWigs_SetRaidIcon", pplayer)
		end
	end
end

